Index: /branches/SHM-6-dev/build/vc9/TLibCommon_vc9.vcproj
===================================================================
--- /branches/SHM-6-dev/build/vc9/TLibCommon_vc9.vcproj	(revision 680)
+++ /branches/SHM-6-dev/build/vc9/TLibCommon_vc9.vcproj	(revision 681)
@@ -300,4 +300,8 @@
 			</File>
 			<File
+				RelativePath="..\..\source\Lib\TLibCommon\TCom3DAsymLUT.cpp"
+				>
+			</File>
+			<File
 				RelativePath="..\..\source\Lib\TLibCommon\TComBitStream.cpp"
 				>
@@ -426,4 +430,8 @@
 			</File>
 			<File
+				RelativePath="..\..\source\Lib\TLibCommon\TCom3DAsymLUT.h"
+				>
+			</File>
+			<File
 				RelativePath="..\..\source\Lib\TLibCommon\TComBitCounter.h"
 				>
Index: /branches/SHM-6-dev/build/vc9/TLibEncoder_vc9.vcproj
===================================================================
--- /branches/SHM-6-dev/build/vc9/TLibEncoder_vc9.vcproj	(revision 680)
+++ /branches/SHM-6-dev/build/vc9/TLibEncoder_vc9.vcproj	(revision 681)
@@ -295,4 +295,8 @@
 			</File>
 			<File
+				RelativePath="..\..\source\Lib\TLibEncoder\TEnc3DAsymLUT.cpp"
+				>
+			</File>
+			<File
 				RelativePath="..\..\source\Lib\TLibEncoder\TEncAnalyze.cpp"
 				>
@@ -377,4 +381,8 @@
 			<File
 				RelativePath="..\..\source\Lib\TLibEncoder\SyntaxElementWriter.h"
+				>
+			</File>
+			<File
+				RelativePath="..\..\source\Lib\TLibEncoder\TEnc3DAsymLUT.h"
 				>
 			</File>
Index: /branches/SHM-6-dev/cfg/per-sequence-svc/CGS-Birthday-b10-1x.cfg
===================================================================
--- /branches/SHM-6-dev/cfg/per-sequence-svc/CGS-Birthday-b10-1x.cfg	(revision 680)
+++ /branches/SHM-6-dev/cfg/per-sequence-svc/CGS-Birthday-b10-1x.cfg	(revision 681)
@@ -12,4 +12,5 @@
 QP0                           : 22
 InputBitDepth0                : 10           # Input bitdepth
+InternalBitDepth0             : 10           # codec operating bit-depth for layer 0
 
 InputFile1                    :  /prj/MMRnD/svc_sequence/CGS3/BT2020_Birthday_1920x1080_60_10bit_zerophase_0.9pi.yuv
@@ -21,4 +22,5 @@
 QP1                           : 20
 InputBitDepth1                : 10           # Input bitdepth
+InternalBitDepth1             : 10           # codec operating bit-depth for layer 1
 
 PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
Index: /branches/SHM-6-dev/cfg/per-sequence-svc/CGS-Birthday-b8-2x.cfg
===================================================================
--- /branches/SHM-6-dev/cfg/per-sequence-svc/CGS-Birthday-b8-2x.cfg	(revision 680)
+++ /branches/SHM-6-dev/cfg/per-sequence-svc/CGS-Birthday-b8-2x.cfg	(revision 681)
@@ -12,4 +12,5 @@
 QP0                           : 22
 InputBitDepth0                : 8           # Input bitdepth
+InternalBitDepth0             : 8           # codec operating bit-depth for layer 0
 
 InputFile1                    :  /prj/MMRnD/svc_sequence/CGS3/BT2020_Birthday_3840x2160_60_10bit.yuv
@@ -21,4 +22,5 @@
 QP1                           : 20
 InputBitDepth1                : 10           # Input bitdepth
+InternalBitDepth1             : 10           # codec operating bit-depth for layer 1
 
 PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
Index: /branches/SHM-6-dev/cfg/per-sequence-svc/CGS-BirthdayFlashPart1-b10-1x.cfg
===================================================================
--- /branches/SHM-6-dev/cfg/per-sequence-svc/CGS-BirthdayFlashPart1-b10-1x.cfg	(revision 680)
+++ /branches/SHM-6-dev/cfg/per-sequence-svc/CGS-BirthdayFlashPart1-b10-1x.cfg	(revision 681)
@@ -12,4 +12,5 @@
 QP0                           : 22
 InputBitDepth0                : 10           # Input bitdepth
+InternalBitDepth0             : 10           # codec operating bit-depth for layer 0
 
 InputFile1                    :  /prj/MMRnD/svc_sequence/CGS3/BT2020_BirthdayFlashPart1_1920x1080_60_10bit_zerophase_0.9pi.yuv
@@ -21,4 +22,5 @@
 QP1                           : 20
 InputBitDepth1                : 10           # Input bitdepth
+InternalBitDepth1             : 10           # codec operating bit-depth for layer 1
 
 PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
Index: /branches/SHM-6-dev/cfg/per-sequence-svc/CGS-BirthdayFlashPart1-b8-2x.cfg
===================================================================
--- /branches/SHM-6-dev/cfg/per-sequence-svc/CGS-BirthdayFlashPart1-b8-2x.cfg	(revision 680)
+++ /branches/SHM-6-dev/cfg/per-sequence-svc/CGS-BirthdayFlashPart1-b8-2x.cfg	(revision 681)
@@ -12,4 +12,5 @@
 QP0                           : 22
 InputBitDepth0                : 8           # Input bitdepth
+InternalBitDepth0             : 8           # codec operating bit-depth for layer 0
 
 InputFile1                    :  /prj/MMRnD/svc_sequence/CGS3/BT2020_BirthdayFlashPart1_3840x2160_60_10bit.yuv
@@ -21,4 +22,5 @@
 QP1                           : 20
 InputBitDepth1                : 10           # Input bitdepth
+InternalBitDepth1             : 10           # codec operating bit-depth for layer 1
 
 PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
Index: /branches/SHM-6-dev/cfg/per-sequence-svc/CGS-BirthdayFlashPart2-b10-1x.cfg
===================================================================
--- /branches/SHM-6-dev/cfg/per-sequence-svc/CGS-BirthdayFlashPart2-b10-1x.cfg	(revision 680)
+++ /branches/SHM-6-dev/cfg/per-sequence-svc/CGS-BirthdayFlashPart2-b10-1x.cfg	(revision 681)
@@ -12,4 +12,5 @@
 QP0                           : 22
 InputBitDepth0                : 10           # Input bitdepth
+InternalBitDepth0             : 10           # codec operating bit-depth for layer 0
 
 InputFile1                    :  /prj/MMRnD/svc_sequence/CGS3/BT2020_BirthdayFlashPart2_1920x1080_60_10bit_zerophase_0.9pi.yuv
@@ -21,4 +22,5 @@
 QP1                           : 20
 InputBitDepth1                : 10           # Input bitdepth
+InternalBitDepth1             : 10           # codec operating bit-depth for layer 1
 
 PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
Index: /branches/SHM-6-dev/cfg/per-sequence-svc/CGS-BirthdayFlashPart2-b8-2x.cfg
===================================================================
--- /branches/SHM-6-dev/cfg/per-sequence-svc/CGS-BirthdayFlashPart2-b8-2x.cfg	(revision 680)
+++ /branches/SHM-6-dev/cfg/per-sequence-svc/CGS-BirthdayFlashPart2-b8-2x.cfg	(revision 681)
@@ -12,4 +12,5 @@
 QP0                           : 22
 InputBitDepth0                : 8           # Input bitdepth
+InternalBitDepth0             : 8           # codec operating bit-depth for layer 0
 
 InputFile1                    :  /prj/MMRnD/svc_sequence/CGS3/BT2020_BirthdayFlashPart2_3840x2160_60_10bit.yuv
@@ -21,4 +22,5 @@
 QP1                           : 20
 InputBitDepth1                : 10           # Input bitdepth
+InternalBitDepth1             : 10           # codec operating bit-depth for layer 1
 
 PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
Index: /branches/SHM-6-dev/cfg/per-sequence-svc/CGS-Parakeets-b10-1x.cfg
===================================================================
--- /branches/SHM-6-dev/cfg/per-sequence-svc/CGS-Parakeets-b10-1x.cfg	(revision 680)
+++ /branches/SHM-6-dev/cfg/per-sequence-svc/CGS-Parakeets-b10-1x.cfg	(revision 681)
@@ -12,4 +12,5 @@
 QP0                           : 22
 InputBitDepth0                : 10           # Input bitdepth
+InternalBitDepth0             : 10           # codec operating bit-depth for layer 0
 
 InputFile1                    :  /prj/MMRnD/svc_sequence/CGS3/BT2020_Parakeets_1920x1080_50_10bit_zerophase_0.9pi.yuv
@@ -21,4 +22,5 @@
 QP1                           : 20
 InputBitDepth1                : 10           # Input bitdepth
+InternalBitDepth1             : 10           # codec operating bit-depth for layer 1
 
 PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
Index: /branches/SHM-6-dev/cfg/per-sequence-svc/CGS-Parakeets-b8-2x.cfg
===================================================================
--- /branches/SHM-6-dev/cfg/per-sequence-svc/CGS-Parakeets-b8-2x.cfg	(revision 680)
+++ /branches/SHM-6-dev/cfg/per-sequence-svc/CGS-Parakeets-b8-2x.cfg	(revision 681)
@@ -12,4 +12,5 @@
 QP0                           : 22
 InputBitDepth0                : 8           # Input bitdepth
+InternalBitDepth0             : 8           # codec operating bit-depth for layer 0
 
 InputFile1                    :  /prj/MMRnD/svc_sequence/CGS3/BT2020_Parakeets_3840x2160_50_10bit.yuv
@@ -21,4 +22,5 @@
 QP1                           : 20
 InputBitDepth1                : 10           # Input bitdepth
+InternalBitDepth1             : 10           # codec operating bit-depth for layer 1
 
 PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
Index: /branches/SHM-6-dev/cfg/per-sequence-svc/CGS-TableCar-b10-1x.cfg
===================================================================
--- /branches/SHM-6-dev/cfg/per-sequence-svc/CGS-TableCar-b10-1x.cfg	(revision 680)
+++ /branches/SHM-6-dev/cfg/per-sequence-svc/CGS-TableCar-b10-1x.cfg	(revision 681)
@@ -12,4 +12,5 @@
 QP0                           : 22
 InputBitDepth0                : 10           # Input bitdepth
+InternalBitDepth0             : 10           # codec operating bit-depth for layer 0
 
 InputFile1                    :  /prj/MMRnD/svc_sequence/CGS3/BT2020_TableCar_1920x1080_60_10bit_zerophase_0.9pi.yuv
@@ -21,4 +22,5 @@
 QP1                           : 20
 InputBitDepth1                : 10           # Input bitdepth
+InternalBitDepth1             : 10           # codec operating bit-depth for layer 1
 
 PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
Index: /branches/SHM-6-dev/cfg/per-sequence-svc/CGS-TableCar-b8-2x.cfg
===================================================================
--- /branches/SHM-6-dev/cfg/per-sequence-svc/CGS-TableCar-b8-2x.cfg	(revision 680)
+++ /branches/SHM-6-dev/cfg/per-sequence-svc/CGS-TableCar-b8-2x.cfg	(revision 681)
@@ -12,4 +12,5 @@
 QP0                           : 22
 InputBitDepth0                : 8           # Input bitdepth
+InternalBitDepth0             : 8           # codec operating bit-depth for layer 0
 
 InputFile1                    :  /prj/MMRnD/svc_sequence/CGS3/BT2020_TableCar_3840x2160_60_10bit.yuv
@@ -21,4 +22,5 @@
 QP1                           : 20
 InputBitDepth1                : 10           # Input bitdepth
+InternalBitDepth1             : 10           # codec operating bit-depth for layer 1
 
 PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)