Index: /branches/SHM-6-dev/source/App/TAppEncoder/TAppEncTop.cpp
===================================================================
--- /branches/SHM-6-dev/source/App/TAppEncoder/TAppEncTop.cpp	(revision 696)
+++ /branches/SHM-6-dev/source/App/TAppEncoder/TAppEncTop.cpp	(revision 697)
@@ -481,6 +481,5 @@
     m_acTEncTop[layer].setTMISEIExtendedWhiteLevelLumaCodeValue     ( m_extendedWhiteLevelLumaCodeValue );
 #if Q0074_SEI_COLOR_MAPPING
-    string  cTmp  = m_acLayerCfg[layer].m_cSeiColorMappingFile;
-    m_acTEncTop[layer].setColorMappingInfoSEIFile                   ( cTmp.empty() ? NULL : strdup(cTmp.c_str()) );
+    m_acTEncTop[layer].setColorMappingInfoSEIFile                   ( m_acLayerCfg[layer].m_cSeiColorMappingFile.empty() ? NULL : const_cast<Char *>(m_acLayerCfg[layer].m_cSeiColorMappingFile.c_str()) );
 #endif
     m_acTEncTop[layer].setFramePackingArrangementSEIEnabled( m_framePackingSEIEnabled );
Index: /branches/SHM-6-dev/source/Lib/TLibCommon/SEI.h
===================================================================
--- /branches/SHM-6-dev/source/Lib/TLibCommon/SEI.h	(revision 696)
+++ /branches/SHM-6-dev/source/Lib/TLibCommon/SEI.h	(revision 697)
@@ -417,13 +417,13 @@
   virtual ~SEIColorMappingInfo() {}
 
-  Int   m_colorMapId;
-  Bool  m_colorMapCancelFlag;
-  Bool  m_colorMapPersistenceFlag;
-  Bool  m_colorMap_video_signal_type_present_flag;
-  Bool  m_colorMap_video_full_range_flag;
-  UChar m_colorMap_primaries;
-  UChar m_colorMap_transfer_characteristics;
-  UChar m_colorMap_matrix_coeffs;
-  UChar m_colorMapModelId;
+  Int    m_colorMapId;
+  Bool   m_colorMapCancelFlag;
+  Bool   m_colorMapPersistenceFlag;
+  Bool   m_colorMap_video_signal_type_present_flag;
+  Bool   m_colorMap_video_full_range_flag;
+  UShort m_colorMap_primaries;
+  UShort m_colorMap_transfer_characteristics;
+  UShort m_colorMap_matrix_coeffs;
+  UShort m_colorMapModelId;
 
   Int   m_colour_map_coded_data_bit_depth;
Index: /branches/SHM-6-dev/source/Lib/TLibDecoder/TDecTop.cpp
===================================================================
--- /branches/SHM-6-dev/source/Lib/TLibDecoder/TDecTop.cpp	(revision 696)
+++ /branches/SHM-6-dev/source/Lib/TLibDecoder/TDecTop.cpp	(revision 697)
@@ -2631,5 +2631,5 @@
     Int   cShift  = 1 ;
 
-    Pel*  LumPrev0 = Lum0;
+    //Pel*  LumPrev0 = Lum0;
     for( Int y = 0; y < iHeight ; y++ )
     {
@@ -2689,5 +2689,5 @@
       }
 
-      LumPrev0 = Lum0;
+      //LumPrev0 = Lum0;
       Lum0  += iStride;
       Lum1  += iStride;
Index: /branches/SHM-6-dev/source/Lib/TLibDecoder/TDecTop.h
===================================================================
--- /branches/SHM-6-dev/source/Lib/TLibDecoder/TDecTop.h	(revision 696)
+++ /branches/SHM-6-dev/source/Lib/TLibDecoder/TDecTop.h	(revision 697)
@@ -67,13 +67,13 @@
 class TDecColorMapping
 {
-  Int   m_colorMapId;
-  Bool  m_colorMapCancelFlag;
-  Bool  m_colorMapPersistenceFlag;
-  Bool  m_colorMap_video_signal_type_present_flag;
-  Bool  m_colorMap_video_full_range_flag;
-  UChar m_colorMap_primaries;
-  UChar m_colorMap_transfer_characteristics;
-  UChar m_colorMap_matrix_coeffs;
-  UChar m_colorMapModelId;
+  Int    m_colorMapId;
+  Bool   m_colorMapCancelFlag;
+  Bool   m_colorMapPersistenceFlag;
+  Bool   m_colorMap_video_signal_type_present_flag;
+  Bool   m_colorMap_video_full_range_flag;
+  UShort m_colorMap_primaries;
+  UShort m_colorMap_transfer_characteristics;
+  UShort m_colorMap_matrix_coeffs;
+  UShort m_colorMapModelId;
 
   Int   m_colour_map_coded_data_bit_depth;
Index: /branches/SHM-6-dev/source/Lib/TLibEncoder/SEIwrite.h
===================================================================
--- /branches/SHM-6-dev/source/Lib/TLibEncoder/SEIwrite.h	(revision 696)
+++ /branches/SHM-6-dev/source/Lib/TLibEncoder/SEIwrite.h	(revision 697)
@@ -73,5 +73,5 @@
   Void xWriteSEIToneMappingInfo(const SEIToneMappingInfo& sei);
 #if Q0074_SEI_COLOR_MAPPING
-  Void SEIWriter::xWriteSEIColorMappingInfo(const SEIColorMappingInfo& sei);
+  Void xWriteSEIColorMappingInfo(const SEIColorMappingInfo& sei);
 #endif
   Void xWriteSEISOPDescription(const SEISOPDescription& sei);