Index: /branches/HTM-8.2-dev3-Samsung/cfg/3D-HEVC/NonCTC/fco/baseCfg_3view+depth.cfg
===================================================================
--- /branches/HTM-8.2-dev3-Samsung/cfg/3D-HEVC/NonCTC/fco/baseCfg_3view+depth.cfg	(revision 698)
+++ /branches/HTM-8.2-dev3-Samsung/cfg/3D-HEVC/NonCTC/fco/baseCfg_3view+depth.cfg	(revision 699)
@@ -227,5 +227,5 @@
 IvMvPred                            : 1                # Inter-view motion prediction
 AdvMultiviewResPred                 : 1                # Advanced inter-view residual prediction (0:off, 1:on)
-IlluCompEnable                      : 1 1              # Enable Illumination compensation ( 0: off, 1: on )  (v/d)
+IlluCompEnable                      : 1                # Enable Illumination compensation ( 0: off, 1: on )  (v/d)
 ViewSynthesisPred                   : 1                # View synthesis prediction 
 DepthRefinement                     : 1                # Dispary refined by depth DoNBDV
Index: /branches/HTM-8.2-dev3-Samsung/cfg/3D-HEVC/NonCTC/rc/baseCfg_3view+depth_rate_control.cfg
===================================================================
--- /branches/HTM-8.2-dev3-Samsung/cfg/3D-HEVC/NonCTC/rc/baseCfg_3view+depth_rate_control.cfg	(revision 698)
+++ /branches/HTM-8.2-dev3-Samsung/cfg/3D-HEVC/NonCTC/rc/baseCfg_3view+depth_rate_control.cfg	(revision 699)
@@ -239,5 +239,5 @@
 IvMvPred                            : 1                # Inter-view motion prediction
 AdvMultiviewResPred                 : 1                # Advanced inter-view residual prediction (0:off, 1:on)
-IlluCompEnable                      : 1 1              # Enable Illumination compensation ( 0: off, 1: on )  (v/d)
+IlluCompEnable                      : 1                # Enable Illumination compensation ( 0: off, 1: on )  (v/d)
 ViewSynthesisPred                   : 1                # View synthesis prediction 
 DepthRefinement                     : 1                # Dispary refined by depth DoNBDV
Index: /branches/HTM-8.2-dev3-Samsung/cfg/3D-HEVC/baseCfg_2view+depth.cfg
===================================================================
--- /branches/HTM-8.2-dev3-Samsung/cfg/3D-HEVC/baseCfg_2view+depth.cfg	(revision 698)
+++ /branches/HTM-8.2-dev3-Samsung/cfg/3D-HEVC/baseCfg_2view+depth.cfg	(revision 699)
@@ -197,5 +197,5 @@
 IvMvPred                            : 1                # Inter-view motion prediction
 AdvMultiviewResPred                 : 1                # Advanced inter-view residual prediction (0:off, 1:on)
-IlluCompEnable                      : 1 1              # Enable Illumination compensation ( 0: off, 1: on )   (v/d) 
+IlluCompEnable                      : 1                # Enable Illumination compensation ( 0: off, 1: on )   (v/d) 
 ViewSynthesisPred                   : 1                # View synthesis prediction 
 DepthRefinement                     : 1                # Dispary refined by depth DoNBDV
Index: /branches/HTM-8.2-dev3-Samsung/cfg/3D-HEVC/baseCfg_2view.cfg
===================================================================
--- /branches/HTM-8.2-dev3-Samsung/cfg/3D-HEVC/baseCfg_2view.cfg	(revision 698)
+++ /branches/HTM-8.2-dev3-Samsung/cfg/3D-HEVC/baseCfg_2view.cfg	(revision 699)
@@ -170,5 +170,5 @@
 IvMvPred                            : 1                # Inter-view motion prediction
 AdvMultiviewResPred                 : 1                # Advanced inter-view residual prediction (0:off, 1:on)
-IlluCompEnable                      : 1 1              # Enable Illumination compensation ( 0: off, 1: on ) (v/d)
+IlluCompEnable                      : 1                # Enable Illumination compensation ( 0: off, 1: on ) (v/d)
 ViewSynthesisPred                   : 1                # View synthesis prediction 
 DepthRefinement                     : 1                # Dispary refined by depth DoNBDV
Index: /branches/HTM-8.2-dev3-Samsung/cfg/3D-HEVC/baseCfg_3view+depth.cfg
===================================================================
--- /branches/HTM-8.2-dev3-Samsung/cfg/3D-HEVC/baseCfg_3view+depth.cfg	(revision 698)
+++ /branches/HTM-8.2-dev3-Samsung/cfg/3D-HEVC/baseCfg_3view+depth.cfg	(revision 699)
@@ -227,5 +227,5 @@
 IvMvPred                            : 1                # Inter-view motion prediction
 AdvMultiviewResPred                 : 1                # Advanced inter-view residual prediction (0:off, 1:on)
-IlluCompEnable                      : 1 1              # Enable Illumination compensation ( 0: off, 1: on )  (v/d)
+IlluCompEnable                      : 1                # Enable Illumination compensation ( 0: off, 1: on )  (v/d)
 ViewSynthesisPred                   : 1                # View synthesis prediction 
 DepthRefinement                     : 1                # Dispary refined by depth DoNBDV
Index: /branches/HTM-8.2-dev3-Samsung/cfg/3D-HEVC/fullCfg.cfg
===================================================================
--- /branches/HTM-8.2-dev3-Samsung/cfg/3D-HEVC/fullCfg.cfg	(revision 698)
+++ /branches/HTM-8.2-dev3-Samsung/cfg/3D-HEVC/fullCfg.cfg	(revision 699)
@@ -254,5 +254,5 @@
 IvMvPred                            : 1                # Inter-view motion prediction
 AdvMultiviewResPred                 : 1                # Advanced inter-view residual prediction (0:off, 1:on)
-IlluCompEnable                      : 1 1              # Enable Illumination compensation ( 0: off, 1: on ) (v/d)
+IlluCompEnable                      : 1                # Enable Illumination compensation ( 0: off, 1: on ) (v/d)
 ViewSynthesisPred                   : 1                # View synthesis prediction 
 DepthRefinement                     : 1                # Dispary refined by depth DoNBDV
Index: /branches/HTM-8.2-dev3-Samsung/source/App/TAppEncoder/TAppEncCfg.cpp
===================================================================
--- /branches/HTM-8.2-dev3-Samsung/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 698)
+++ /branches/HTM-8.2-dev3-Samsung/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 699)
@@ -511,5 +511,9 @@
 #endif
 #if H_3D_IC
+#if SEC_ONLY_TEXTURE_IC_F0151
+  ("IlluCompEnable",           m_abUseIC, true, "Enable illumination compensation")
+#else
   ("IlluCompEnable",           m_abUseIC, std::vector<Bool>(2, true), "Enable illumination compensation")
+#endif
 #endif
 #if H_3D_INTER_SDC
@@ -2422,5 +2426,9 @@
 #endif
 #if H_3D_IC
+#if SEC_ONLY_TEXTURE_IC_F0151
+  printf( "IlluCompEnable: %d ", m_abUseIC);
+#else
   printf( "IlluCompEnable: %d %d ", m_abUseIC[0] ? 1 : 0, m_abUseIC[1] ? 1 : 0 );
+#endif
 #endif
 #if H_3D_NBDV_REF
Index: /branches/HTM-8.2-dev3-Samsung/source/App/TAppEncoder/TAppEncCfg.h
===================================================================
--- /branches/HTM-8.2-dev3-Samsung/source/App/TAppEncoder/TAppEncCfg.h	(revision 698)
+++ /branches/HTM-8.2-dev3-Samsung/source/App/TAppEncoder/TAppEncCfg.h	(revision 699)
@@ -122,5 +122,9 @@
 #endif
 #if H_3D_IC
+#if SEC_ONLY_TEXTURE_IC_F0151
+  Bool   m_abUseIC;
+#else
   vector<Bool> m_abUseIC;                                    ///< flag for using illumination compensation for inter-view prediction
+#endif
 #endif
 #if H_3D_NBDV_REF
Index: /branches/HTM-8.2-dev3-Samsung/source/App/TAppEncoder/TAppEncTop.cpp
===================================================================
--- /branches/HTM-8.2-dev3-Samsung/source/App/TAppEncoder/TAppEncTop.cpp	(revision 698)
+++ /branches/HTM-8.2-dev3-Samsung/source/App/TAppEncoder/TAppEncTop.cpp	(revision 699)
@@ -177,5 +177,9 @@
 #endif
 #if H_3D_IC
+#if SEC_ONLY_TEXTURE_IC_F0151
+    m_cTEncTop.setUseIC                        ( vps.getViewIndex( layerId ) == 0 || isDepth ? false : m_abUseIC );
+#else
     m_cTEncTop.setUseIC                        ( vps.getViewIndex( layerId ) == 0 ? false : m_abUseIC[isDepth ? 1 : 0] );
+#endif
 #endif
   //========== Depth intra modes ==========
Index: /branches/HTM-8.2-dev3-Samsung/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- /branches/HTM-8.2-dev3-Samsung/source/Lib/TLibCommon/TypeDef.h	(revision 698)
+++ /branches/HTM-8.2-dev3-Samsung/source/Lib/TLibCommon/TypeDef.h	(revision 699)
@@ -107,4 +107,5 @@
 
 #define LGE_IC_CTX_F0160 1 //JCT3V-F0160
+#define SEC_ONLY_TEXTURE_IC_F0151         1
 
 #if H_3D_NBDV
Index: /branches/HTM-8.2-dev3-Samsung/source/Lib/TLibDecoder/TDecCAVLC.cpp
===================================================================
--- /branches/HTM-8.2-dev3-Samsung/source/Lib/TLibDecoder/TDecCAVLC.cpp	(revision 698)
+++ /branches/HTM-8.2-dev3-Samsung/source/Lib/TLibDecoder/TDecCAVLC.cpp	(revision 699)
@@ -1795,5 +1795,9 @@
     }
 #if H_3D_IC
+#if SEC_ONLY_TEXTURE_IC_F0151
+    else if( rpcSlice->getViewIndex() && ( rpcSlice->getSliceType() == P_SLICE || rpcSlice->getSliceType() == B_SLICE ) && !rpcSlice->getIsDepth())
+#else
     else if( rpcSlice->getViewIndex() && ( rpcSlice->getSliceType() == P_SLICE || rpcSlice->getSliceType() == B_SLICE ) )
+#endif
     {
       UInt uiCodeTmp = 0;
Index: /branches/HTM-8.2-dev3-Samsung/source/Lib/TLibDecoder/TDecEntropy.cpp
===================================================================
--- /branches/HTM-8.2-dev3-Samsung/source/Lib/TLibDecoder/TDecEntropy.cpp	(revision 698)
+++ /branches/HTM-8.2-dev3-Samsung/source/Lib/TLibDecoder/TDecEntropy.cpp	(revision 699)
@@ -111,5 +111,9 @@
   pcCU->setICFlagSubParts( false , uiAbsPartIdx, 0, uiDepth );
 
+#if SEC_ONLY_TEXTURE_IC_F0151
+  if ( pcCU->isIntra( uiAbsPartIdx ) || ( pcCU->getSlice()->getViewIndex() == 0 ) || pcCU->getSlice()->getIsDepth() )
+#else
   if ( pcCU->isIntra( uiAbsPartIdx ) || ( pcCU->getSlice()->getViewIndex() == 0 ) )
+#endif
   {
     return;
Index: /branches/HTM-8.2-dev3-Samsung/source/Lib/TLibEncoder/TEncCavlc.cpp
===================================================================
--- /branches/HTM-8.2-dev3-Samsung/source/Lib/TLibEncoder/TEncCavlc.cpp	(revision 698)
+++ /branches/HTM-8.2-dev3-Samsung/source/Lib/TLibEncoder/TEncCavlc.cpp	(revision 699)
@@ -1387,5 +1387,9 @@
     }
 #if H_3D_IC
+#if SEC_ONLY_TEXTURE_IC_F0151
+    else if( pcSlice->getViewIndex() && ( pcSlice->getSliceType() == P_SLICE || pcSlice->getSliceType() == B_SLICE ) && !pcSlice->getIsDepth())
+#else
     else if( pcSlice->getViewIndex() && ( pcSlice->getSliceType() == P_SLICE || pcSlice->getSliceType() == B_SLICE ) )
+#endif
     {
       WRITE_FLAG( pcSlice->getApplyIC() ? 1 : 0, "slice_ic_enable_flag" );
Index: /branches/HTM-8.2-dev3-Samsung/source/Lib/TLibEncoder/TEncCu.cpp
===================================================================
--- /branches/HTM-8.2-dev3-Samsung/source/Lib/TLibEncoder/TEncCu.cpp	(revision 698)
+++ /branches/HTM-8.2-dev3-Samsung/source/Lib/TLibEncoder/TEncCu.cpp	(revision 699)
@@ -497,5 +497,9 @@
 #endif
 #if H_3D_IC
+#if SEC_ONLY_TEXTURE_IC_F0151
+  Bool bICEnabled = rpcTempCU->getSlice()->getViewIndex() && ( rpcTempCU->getSlice()->getSliceType() == P_SLICE || rpcTempCU->getSlice()->getSliceType() == B_SLICE ) && !rpcTempCU->getSlice()->getIsDepth();
+#else
   Bool bICEnabled = rpcTempCU->getSlice()->getViewIndex() && ( rpcTempCU->getSlice()->getSliceType() == P_SLICE || rpcTempCU->getSlice()->getSliceType() == B_SLICE );
+#endif
   bICEnabled = bICEnabled && rpcTempCU->getSlice()->getApplyIC();
 #endif
Index: /branches/HTM-8.2-dev3-Samsung/source/Lib/TLibEncoder/TEncEntropy.cpp
===================================================================
--- /branches/HTM-8.2-dev3-Samsung/source/Lib/TLibEncoder/TEncEntropy.cpp	(revision 698)
+++ /branches/HTM-8.2-dev3-Samsung/source/Lib/TLibEncoder/TEncEntropy.cpp	(revision 699)
@@ -160,5 +160,9 @@
 Void TEncEntropy::encodeICFlag( TComDataCU* pcCU, UInt uiAbsPartIdx, Bool bRD )
 {
+#if SEC_ONLY_TEXTURE_IC_F0151
+  if ( pcCU->isIntra( uiAbsPartIdx ) || ( pcCU->getSlice()->getViewIndex() == 0 ) || pcCU->getSlice()->getIsDepth() )
+#else
   if ( pcCU->isIntra( uiAbsPartIdx ) || ( pcCU->getSlice()->getViewIndex() == 0 ) )
+#endif
   {
     return;